# -*- coding: utf-8 -*-
"""
/***************************************************************************
PostgisQueryDialog
A QGIS plugin
Editor to build and perform PostGIS SQL Queries and adds the resulting vector layer to MapCanvas
                             -------------------
begin                : 2009-03-06 
copyright            : (C) 2009 by Dr. Horst Duester / SO!GIS
email                : horst.duester@kappasys.ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from qgis.gui import *
from postgisquery import version
from Ui_PostgisQuery import Ui_PostgisQueryEditor

# create the dialog for PostgisQuery
class PostgisQueryDialog(QDialog, Ui_PostgisQueryEditor):
  
  loadLayer = pyqtSignal(str)
  openFileDialog = pyqtSignal()
  loadFile = pyqtSignal()      
  saveFile = pyqtSignal()
     
     
  def __init__(self, parent, fl):
     QDialog.__init__(self, parent, fl)
     self.setupUi(self)
     self.setWindowTitle(version())

    
  def initGui(self):
     settings = QSettings()
     settings.beginGroup("PostgreSQL/connections")
     self.cmbServer.addItems(settings.childGroups())
     settings.endGroup()
     selectedDb = settings.value(pystring("PostgreSQL/connections/selected"))
     cmbIndex = self.cmbServer.findText(selectedDb, Qt.MatchExactly)
     self.cmbServer.setCurrentIndex(cmbIndex)
     self.setWindowTitle('PostgisQuery-Editor '+version())
     pass    
    
  @pyqtSignature("on_btnOk_clicked()")      
  def on_btnOk_clicked(self):
     myCursor = self.txtEditSql.textCursor()
     selText = myCursor.selectedText()
     if len(selText) == 0:
       self.query = pystring(self.txtEditSql.toPlainText())
     else:
       self.query =  pystring(selText.simplified())
     self.loadLayer.emit( self.query )       
     pass
     
  @pyqtSignature("on_btnTmpPath_clicked()")      
  def on_btnTmpPath_clicked(self):
     self.openFileDialog.emit()       
     pass     
    
  @pyqtSignature("on_btnClear_clicked()")      
  def on_btnClear_clicked(self):
     settings = QSettings()
     settings.setValue("/Plugin-PostGISQuery/query", pystring(""))
     self.txtEditSql.setText("")
     pass         

  @pyqtSignature("on_btnExit_clicked()")          
  def on_btnExit_clicked(self):
     settings = QSettings()
     settings.setValue("/Plugin-PostGISQuery/query", pystring(self.txtEditSql.toPlainText()))     
     self.close()
     
  @pyqtSignature("on_btnLoad_clicked()")           
  def on_btnLoad_clicked(self):
    self.loadFile.emit()       
    pass
    
  @pyqtSignature("on_btnSave_clicked()")           
  def on_btnSave_clicked(self):
    self.saveFile.emit()       
    pass    
     
